<?php
 class wpsg_mod_rechnungen extends wpsg_mod_basic { var $lizenz = 1; var $id = 1400; var $version = "3.1.0"; var $hilfeURL = 'http://wpshopgermany.de/?p=718'; var $free = false; var $data = array(); public function __construct() { parent::__construct(); $this->name = __('Rechnungen', 'wpsg'); $this->group = __('Bestellung', 'wpsg'); $this->desc = __('Ermöglicht es PDF Rechnungen zu Bestellungen zu generieren.', 'wpsg'); $this->fields = array( 'firma' => __('Firmenname', 'wpsg'), 'name' => __('Name', 'wpsg'), 'strasse' => __('Strasse', 'wpsg'), 'plzort' => __('PLZ/Ort', 'wpsg'), 'tel' => __('Tel', 'wpsg'), 'fax' => __('Fax', 'wpsg'), 'mail' => __('E-Mail', 'wpsg'), 'web' => __('Web', 'wpsg'), 'strnr' => __('Steuer-Nr', 'wpsg'), 'ustidnr' => __('UStIdNr.', 'wpsg'), 'knr' => __('Kontonummer', 'wpsg'), 'blz' => __('BLZ', 'wpsg'), 'bank' => __('Bank', 'wpsg'), 'user1' => __('Benutzer 1', 'wpsg'), 'user2' => __('Benutzer 2', 'wpsg'), 'user3' => __('Benutzer 3', 'wpsg'), 'user4' => __('Benutzer 4', 'wpsg'), 'user5' => __('Benutzer 5', 'wpsg') ); } public function install() { require_once(WPSG_PATH_WP.'/wp-admin/includes/upgrade.php'); $sql = "CREATE TABLE ".WPSG_TBL_RECHNUNGEN." (
				id int(25) NOT NULL AUTO_INCREMENT,
				o_id int(25) NOT NULL ,
				datum DATETIME NOT NULL ,
				storno DATETIME NOT NULL,
				rnr VARCHAR(255) NOT NULL,
				gnr VARCHAR(255) NOT NULL,
				PRIMARY KEY id (id),
				INDEX o_id (`o_id`)
			) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;"; dbDelta($sql); $this->shop->checkDefault('wpsg_rechnungen_pdfperpage', '10'); } public function delOrder(&$order_id) { $this->db->Query("DELETE FROM `".WPSG_TBL_RECHNUNGEN."` WHERE `o_id` = '".wpsg_q($order_id)."'"); $path = $this->getFilePath($order_id); wpsg_rrmdir($path); } public function pre_get_posts() { if ($_REQUEST['wpsg_action'] == 'wpsg_mod_rechnungen_download') { $hash = md5($this->shop->get_option('wpsg_salt').'wpsg'.$_REQUEST['r_id'].'wpsg'.$this->shop->get_option('wpsg_salt')); if ($hash != $_REQUEST['hash']) { die(__('Kein Zugriff', 'wpsg')); } $this->doDownload($_REQUEST['r_id']); } } public function init() { } public function be_ajax() { if ($_REQUEST['do'] == 'reset') { $this->resetAction(); $this->shop->addBackendMessage(__('Grundeinstellungen wieder hergestellt', 'wpsg')); header('Location: '.WPSG_URL_WP.'wp-admin/admin.php?page=wpsg-Admin&action=module&modul='.$_REQUEST['modul']); die(); } else if ($_REQUEST['do'] == 'inlinedit') { $foot_text = $this->shop->get_option("wpsg_rechnungen_footer"); if (!is_array($foot_text)) $foot_text = @unserialize($foot_text); if (!is_array($foot_text)) $foot_text = array(); $foot_text[$_REQUEST['field_id']][$_REQUEST['field']] = $_REQUEST['value']; $this->shop->update_option('wpsg_rechnungen_footer', $foot_text); die($_REQUEST['value']); } else if ($_REQUEST['do'] == 'add') { $foot_text = $this->shop->get_option("wpsg_rechnungen_footer"); if (!is_array($foot_text)) $foot_text = @unserialize($foot_text); if (!is_array($foot_text)) $foot_text = array(); $new_krzl = __('Zum Bearbeiten anklicken', 'wpsg'); $new_name = __('Zum Bearbeiten anklicken', 'wpsg'); $foot_text[] = array($new_krzl, $new_name); $this->shop->update_option('wpsg_rechnungen_footer', $foot_text); die($this->foottext_list()); } } public function settings_save() { if (file_exists($_FILES['wpsg_rechnungen_bp']['tmp_name'])) { $ending = strtolower(preg_replace("/(.*)\./", "", $_FILES['wpsg_rechnungen_bp']['name'])); if ($ending != "jpg" && $ending != "jpeg" && $ending != "pdf") { $this->shop->addBackendError(__("Ungültiger Dateityp (Briefpapier) ! Es sind nur JPG und PDF Dateien erlaubt!", "wpsg")); } else if ($ending == "jpg" || $ending == "jpeg") { move_uploaded_file($_FILES['wpsg_rechnungen_bp']['tmp_name'], $this->getFilePath('').'wpsg_rechnungen_bp.jpg'); } else if ($ending == "pdf") { move_uploaded_file($_FILES['wpsg_rechnungen_bp']['tmp_name'], $this->getFilePath('').'wpsg_rechnungen_bp.pdf'); } } else if ($_REQUEST['wpsg_rechnungen_bp_del'] == "1") { @unlink($this->getFilePath('').'wpsg_rechnungen_bp.jpg'); @unlink($this->getFilePath('').'wpsg_rechnungen_bp.pdf'); $this->shop->addBackendMessage(__('Briefpapier wurde erfolgreich gelöscht.', 'wpsg')); } if (file_exists($_FILES['wpsg_rechnungen_logo']['tmp_name'])) { $ending = strtolower(preg_replace("/(.*)\./", "", $_FILES['wpsg_rechnungen_logo']['name'])); if ($ending != "jpg" && $ending != "jpeg") { $this->shop->addBackendError(__("Ungültiger Dateityp (Logo) ! Es sind nur JPG und PDF Dateien erlaubt!", "wpsg")); } else if ($ending == "jpg" || $ending == "jpeg") { move_uploaded_file($_FILES['wpsg_rechnungen_logo']['tmp_name'], $this->getFilePath('').'wpsg_rechnungen_logo.jpg'); } } else if ($_REQUEST['wpsg_rechnungen_logo_del'] == "1") { @unlink($this->getFilePath('').'wpsg_rechnungen_logo.jpg'); $this->shop->addBackendMessage(__('Logo wurde erfolgreich gelöscht.', 'wpsg')); } $this->shop->update_option("wpsg_mod_rechnungen_texte", $_REQUEST['text']); $this->shop->update_option("wpsg_rechnungen_url", $_REQUEST['wpsg_rechnungen_url']); $this->shop->update_option("wpsg_mod_rechnungen_auto", $_REQUEST['wpsg_mod_rechnungen_auto']); $this->shop->update_option("wpsg_rechnungen_faelligkeit", $_REQUEST['wpsg_rechnungen_faelligkeit']); $this->shop->update_option('wpsg_rechnungen_pdfperpage', $_REQUEST['wpsg_rechnungen_pdfperpage']); $this->shop->update_option("wpsg_rechnungen_pbeschreibung", $_REQUEST['wpsg_rechnungen_pbeschreibung']); $this->shop->update_option("wpsg_mod_rechnungen_showgutschriftrechnung", $_REQUEST['wpsg_mod_rechnungen_showgutschriftrechnung']); $this->shop->update_option("wpsg_mod_rechnungen_showpv", $_REQUEST['wpsg_mod_rechnungen_showpv']); $this->shop->update_option("wpsg_mod_rechnungen_showov", $_REQUEST['wpsg_mod_rechnungen_showov']); $this->shop->update_option("wpsg_rechnungen_start", $_REQUEST['wpsg_rechnungen_start']); $this->shop->update_option("wpsg_gutschrift_start", $_REQUEST['wpsg_gutschrift_start']); $this->shop->update_option("wpsg_rechnungen_format", $_REQUEST['wpsg_rechnungen_format']); $this->shop->update_option("wpsg_gutschrift_format", $_REQUEST['wpsg_gutschrift_format']); $this->shop->update_option('wpsg_rechnungen_adresszeile', $_REQUEST['wpsg_rechnungen_adresszeile']); $this->shop->update_option('wpsg_rechnungen_foottext_standard', $_REQUEST['wpsg_rechnungen_foottext_standard']); } public function settings_edit() { if (file_exists($this->getFilePath('').'wpsg_rechnungen_bp.jpg')) { $this->shop->view['bp'] = $this->getFilePath('', true).'wpsg_rechnungen_bp.jpg'; } else if (file_exists($this->getFilePath('').'wpsg_rechnungen_bp.pdf')) { $this->shop->view['bp'] = $this->getFilePath('', true).'wpsg_rechnungen_bp.pdf'; } else { $this->shop->view['bp'] = false; } if (file_exists($this->getFilePath('').'wpsg_rechnungen_logo.jpg')) { $this->shop->view['logo'] = $this->getFilePath('', true).'wpsg_rechnungen_logo.jpg'; } else { $this->shop->view['logo'] = false; } $this->shop->view['fields'] = $this->fields; $this->shop->view['foottext_list'] = $this->foottext_list(); $this->shop->view['arTexte'] = $this->shop->get_option('wpsg_mod_rechnungen_texte'); if (!is_array($this->shop->view['arTexte'])) { $this->shop->view['arTexte'] = array(); } $this->shop->render(WPSG_PATH_VIEW.'/mods/mod_rechnungen/settings_edit.phtml'); } public function order_view_content($order_id) { $this->shop->view['mod_rechnungen']['arRechnungen'] = $this->db->fetchAssoc("SELECT * FROM `".WPSG_TBL_RECHNUNGEN."` WHERE `o_id` = '".wpsg_q($order_id)."' AND `storno` = '0000-00-00 00:00:00' AND `gnr` = '' ORDER BY `rnr` DESC"); $this->shop->view['mod_rechnungen']['arRechnungen_storno'] = $this->db->fetchAssoc("SELECT * FROM `".WPSG_TBL_RECHNUNGEN."` WHERE `o_id` = '".wpsg_q($order_id)."' AND `storno` != '0000-00-00 00:00:00' AND `gnr` = '' ORDER BY `rnr` DESC"); $this->shop->view['mod_rechnungen']['arRechnungen_gesamt'] = $this->db->fetchAssoc("
				SELECT 
					*, 
					UNIX_TIMESTAMP(`datum`) AS ts_datum,
					UNIX_TIMESTAMP(`storno`) AS ts_storno
				FROM 
					`".WPSG_TBL_RECHNUNGEN."` 
				WHERE 
					`o_id` = '".wpsg_q($order_id)."' 
				ORDER BY 
					`id` ASC
			"); $this->shop->render(WPSG_PATH_VIEW.'/mods/mod_rechnungen/order_view.phtml'); } public function order_ajax() { if (isset($_REQUEST['wpsg_rechnungen_preview'])) { $this->writeRechnung($_REQUEST['edit_id'], true); die(); } else if (isset($_REQUEST['wpsg_rechnungen_write'])) { $this->writeRechnung($_REQUEST['edit_id'], false); die(); } else if (isset($_REQUEST['do']) && $_REQUEST['do'] == 'getRechnung') { $this->doDownload($_REQUEST['r_id']); } else if (isset($_REQUEST['do']) && $_REQUEST['do'] == 'storno') { $this->stornoAction(); } else if (isset($_REQUEST['do']) && $_REQUEST['do'] == 'copy') { $rechnung = $this->db->fetchRow("SELECT * FROM `".WPSG_TBL_RECHNUNGEN."` WHERE `id` = '".wpsg_q($_REQUEST['r_id'])."'"); if ($rechnung['id'] != $_REQUEST['r_id'] || $_REQUEST['edit_id'] != $rechnung['o_id']) die(__("Rechnung existiert nicht oder passt nicht zur Bestellung!", "wpsg")); $this->shop->view['order'] = $this->shop->cache->loadOrder($rechnung['o_id']); if (trim($this->shop->view['order']['language']) != '') $this->shop->setTempLocale($this->shop->view['order']['language']); $this->shop->view['kunde'] = $this->db->fetchRow("
					SELECT
						K.*
					FROM
						`".WPSG_TBL_KU."` AS K
					WHERE
						K.`id` = '".wpsg_q($this->shop->view['order']['k_id'])."'
				"); $email = $this->shop->view['kunde']['email']; if ($rechnung['gnr'] != "") { if (file_exists($this->getFilePath($_REQUEST['edit_id']).'G'.$rechnung['gnr'].'.pdf')) { $rn_file = $this->getFilePath($_REQUEST['edit_id']).'G'.$rechnung['gnr'].'.pdf'; $rn_file_copy = $this->getFilePath($_REQUEST['edit_id']).'copy_G'.$rechnung['id'].'.pdf'; } else if (file_exists($this->getFilePath($_REQUEST['edit_id']).'G'.$rechnung['id'].'.pdf')) { $rn_file = $this->getFilePath($_REQUEST['edit_id']).'G'.$rechnung['id'].'.pdf'; $rn_file_copy = $this->getFilePath($_REQUEST['edit_id']).'copy_G'.$rechnung['id'].'.pdf'; } $strTitle = wpsg_translate(__('Zusendung einer Kopie für Gutschrift #1# an #2#', 'wpsg'), $rechnung['gnr'], $email); $this->shop->view['gnr'] = $rechnung['gnr']; } else { if (file_exists($this->getFilePath($_REQUEST['edit_id']).'R'.$rechnung['rnr'].'.pdf')) { $rn_file = $this->getFilePath($_REQUEST['edit_id']).'R'.$rechnung['rnr'].'.pdf'; $rn_file_copy = $this->getFilePath($_REQUEST['edit_id']).'copy_R'.$rechnung['id'].'.pdf'; } else if (file_exists($this->getFilePath($_REQUEST['edit_id']).'R'.$rechnung['id'].'.pdf')) { $rn_file = $this->getFilePath($_REQUEST['edit_id']).'R'.$rechnung['id'].'.pdf'; $rn_file_copy = $this->getFilePath($_REQUEST['edit_id']).'copy_R'.$rechnung['id'].'.pdf'; } $strTitle = wpsg_translate(__('Zusendung einer Kopie für Rechnung #1# an #2#', 'wpsg'), $rechnung['rnr'], $email); $this->shop->view['rnr'] = $rechnung['rnr']; } if (!file_exists($rn_file)) die(__("Die Originalrechnung existiert nicht im Dateisystem.", 'wpsg')); include dirname(__FILE__).'/../lib/fpdf/fpdf.php'; include dirname(__FILE__).'/../lib/fpdf/fpdi.php'; include dirname(__FILE__).'/mod_rechnungen/wpsg_fpdf.class.php'; $pdf = new wpsg_fpdf(); $pagecount = $pdf->setSourceFile($rn_file); for ($i = 1; $i <= $pagecount; $i ++) { $tplidx = $pdf->importPage($i, '/MediaBox'); $pdf->addPage(); $pdf->useTemplate($tplidx, 0, 0); $pdf->SetTextColor(125, 125, 125); $pdf->SetFont('Arial', '', 200); $pdf->SetAlpha(0.25); $pdf->TextWithRotation(45, 225, "KOPIE", 45, 0); $pdf->SetAlpha(0); } $pdf->Output($rn_file_copy, 'F'); if (trim($this->shop->view['order']['language']) != '') $this->shop->setTempLocale($this->shop->view['order']['language']); $mail_text = $this->shop->render(WPSG_PATH_VIEW."/mods/mod_rechnungen/copymail.phtml", false); $arFiles = array($rn_file_copy); $this->shop->sendMail($mail_text, $email, 'rechnungscopy', $arFiles); $this->shop->restoreTempLocale(); $this->db->ImportQuery(WPSG_TBL_OL, array( "o_id" => $rechnung['o_id'], "cdate" => "NOW()", "title" => $strTitle, "mailtext" => $mail_text )); $pdf->Output(); die(); } } public function admin_emailconf_save() { $this->shop->update_option('wpsg_rechnungsmail_betreff', $_REQUEST['wpsg_rechnungsmail_betreff']); $this->shop->update_option('wpsg_rechnungsmail_absender', $_REQUEST['wpsg_rechnungsmail_absender']); $this->shop->update_option('wpsg_rechnungsmail_cc', $_REQUEST['wpsg_rechnungsmail_cc']); $this->shop->update_option('wpsg_rechnungsmail_bcc', $_REQUEST['wpsg_rechnungsmail_bcc']); $this->shop->update_option('wpsg_gutschriftmail_betreff', $_REQUEST['wpsg_gutschriftmail_betreff']); $this->shop->update_option('wpsg_gutschriftmail_absender', $_REQUEST['wpsg_gutschriftmail_absender']); $this->shop->update_option('wpsg_gutschriftmail_cc', $_REQUEST['wpsg_gutschriftmail_cc']); $this->shop->update_option('wpsg_gutschriftmail_bcc', $_REQUEST['wpsg_gutschriftmail_bcc']); $this->shop->update_option('wpsg_rechnungscopy_betreff', $_REQUEST['wpsg_rechnungscopy_betreff']); $this->shop->update_option('wpsg_rechnungscopy_absender', $_REQUEST['wpsg_rechnungscopy_absender']); $this->shop->update_option('wpsg_rechnungscopy_cc', $_REQUEST['wpsg_rechnungscopy_cc']); $this->shop->update_option('wpsg_rechnungscopy_bcc', $_REQUEST['wpsg_rechnungscopy_bcc']); } public function admin_emailconf() { $this->shop->render(WPSG_PATH_VIEW.'/mods/mod_rechnungen/emailconf.phtml'); } public function basket_save_done(&$order_id, &$kunde_id, &$oBasket) { if ($this->shop->get_option('wpsg_mod_rechnungen_auto') != '1') return; $this->writeAutoRechnung($order_id); } private function writeGutschrift($order_id, $gnr) { $this->shop->view['data'] = $this->db->fetchRow("
				SELECT
					O.*
				FROM
					`".WPSG_TBL_ORDER."` AS O
				WHERE
					O.`id` = '".wpsg_q($order_id)."'
			"); if (trim($this->shop->view['data']['language']) != '') $this->shop->setTempLocale($this->shop->view['data']['language']); $this->shop->view['kunde'] = $this->db->fetchRow("
				SELECT
					K.*
				FROM
					`".WPSG_TBL_KU."` AS K
				WHERE
					K.`id` = '".wpsg_q($this->shop->view['data']['k_id'])."'
			"); $custom_data = @unserialize($this->shop->view['data']['custom_data']); $this->shop->view['basket'] = $custom_data['basket']; $this->shop->view['kunde']['land'] = $this->db->fetchRow("SELECT L.* FROM `".WPSG_TBL_LAND."` AS L WHERE L.`id` = '".wpsg_q($this->shop->view['kunde']['land'])."'"); $this->shop->view['data']['shipping_land'] = $this->db->fetchRow("SELECT L.* FROM `".WPSG_TBL_LAND."` AS L WHERE L.`id` = '".wpsg_q($this->shop->view['data']['shipping_land'])."'"); $this->shop->view['rDatum'] = date('d.m.Y'); $this->shop->view['title'] = __('Gutschrift', 'wpsg'); $this->shop->view['payment'] = $this->shop->arPayment[$this->shop->view['data']['type_payment']]['name']; $this->shop->view['fussText'] = false; foreach ($this->shop->view['basket']['produkte'] as $k => $v) { $produkt_id = $this->shop->getProduktID($v['id']); $this->shop->view['basket']['produkte'][$k]['beschreibung'] = $this->db->fetchOne("
					SELECT
						P.`beschreibung`
					FROM
						`".WPSG_TBL_PRODUCTS."` AS P
					WHERE
						P.`id` = '".wpsg_q($produkt_id)."'
				"); } $this->shop->view['preview'] = false; $this->shop->view['rnr'] = $gnr; $this->shop->view['filename'] = 'G'.$gnr; $this->shop->view['output'] = true; if ($this->shop->get_option("wpsg_mod_rechnungen_showgutschriftrechnung") == "1") { $last_rnr = $this->db->fetchOne("SELECT `rnr` FROM `".WPSG_TBL_RECHNUNGEN."` WHERE `o_id` = '".wpsg_q($order_id)."' AND `gnr` = '' ORDER BY `datum` DESC LIMIT 1"); $this->shop->view['rnr'] .= ' ('.__("RNr.", "wpsg").' '.$last_rnr.')'; } $this->shop->render(WPSG_PATH_VIEW.'/mods/mod_rechnungen/rechnung_pdf.phtml'); $this->shop->restoreTempLocale(); } public function writeRechnung($order_id, $preview, $bOutput = true) { $this->shop->view['output'] = $bOutput; $this->shop->view['data'] = $this->db->fetchRow("
				SELECT
					O.*
				FROM
					`".WPSG_TBL_ORDER."` AS O
				WHERE
					O.`id` = '".wpsg_q($order_id)."'
			"); if (trim($this->shop->view['data']['language']) != '') $this->shop->setTempLocale($this->shop->view['data']['language']); $this->shop->view['kunde'] = $this->db->fetchRow("
				SELECT
					K.*
				FROM
					`".WPSG_TBL_KU."` AS K
				WHERE
					K.`id` = '".wpsg_q($this->shop->view['data']['k_id'])."'
			"); $custom_data = @unserialize($this->shop->view['data']['custom_data']); $this->shop->view['basket'] = $custom_data['basket']; if (!is_array($custom_data['basket'])) { $basket = new wpsg_basket(); $basket->initFromDB($order_id); $this->shop->view['basket'] = $basket->toArray(); } $this->shop->view['kunde']['land'] = $this->db->fetchRow("SELECT L.* FROM `".WPSG_TBL_LAND."` AS L WHERE L.`id` = '".wpsg_q($this->shop->view['kunde']['land'])."'"); $this->shop->view['data']['shipping_land'] = $this->db->fetchRow("SELECT L.* FROM `".WPSG_TBL_LAND."` AS L WHERE L.`id` = '".wpsg_q($this->shop->view['data']['shipping_land'])."'"); $this->shop->view['rDatum'] = $_REQUEST['wpsg_rechnungen_datum']; $this->shop->view['title'] = __('Rechnung', 'wpsg'); $this->shop->view['payment'] = $this->shop->arPayment[$this->shop->view['data']['type_payment']]['name']; $this->shop->view['fussText'] = $_REQUEST['wpsg_rechnungen_fusstext']; if ($_REQUEST['wpsg_rechnungen_faelligkeit'] == '1') { $this->shop->view['faelligkeitdatum'] = $_REQUEST['wpsg_rechnungen_faelligkeitsdatum']; } foreach ($this->shop->view['basket']['produkte'] as $k => $v) { $produkt_id = $this->shop->getProduktID($v['id']); $this->shop->view['basket']['produkte'][$k]['beschreibung'] = $this->db->fetchOne("
					SELECT
						P.`beschreibung`
					FROM
						`".WPSG_TBL_PRODUCTS."` AS P
					WHERE
						P.`id` = '".wpsg_q($produkt_id)."'
				"); } $rnr_format = $this->shop->get_option("wpsg_rechnungen_format"); if ($rnr_format == "") $rnr_format = "%nr%"; $rnr_nr = intval($this->shop->get_option("wpsg_rechnungen_start")); if ($rnr_nr <= 0) $rnr_nr = 1; $rnr = preg_replace("/\%nr\%/i", $rnr_nr, $rnr_format); $rnr = preg_replace("/\%Jahr\%/i", date("Y"), $rnr); $rnr = preg_replace("/\%Monat\%/i", date("m"), $rnr); $rnr = preg_replace("/\%Tag\%/i", date("d"), $rnr); if ($preview) { $this->shop->view['preview'] = true; $this->shop->view['rnr'] = $rnr.' - '.__('Vorschau', 'wpsg'); $r_id = "Vorschau"; } else { $this->shop->view['preview'] = false; $this->shop->view['rnr'] = $rnr; $this->shop->update_option("wpsg_rechnungen_start", ($rnr_nr + 1)); if ($_REQUEST['wpsg_rechnungen_status'] == "1") { $this->shop->setOrderStatus($order_id, $_REQUEST['wpsg_rechnungen_status_neu'], false); } $r_id = $this->db->importQuery( WPSG_TBL_RECHNUNGEN, array( "rnr" => $rnr, "o_id" => $order_id, "datum" => "NOW()" ) ); } $this->shop->view['filename'] = 'R'.$r_id; $this->shop->render(WPSG_PATH_VIEW.'/mods/mod_rechnungen/rechnung_pdf.phtml'); if (!$preview ) { if (@$_REQUEST['wpsg_rechnungen_sendmail'] == "1") { if (file_exists($this->getFilePath($order_id).$rnr_nr.'.pdf')) { $file = $this->getFilePath($order_id).$rnr_nr.'.pdf'; } else if (file_exists($this->getFilePath($order_id).'R'.$r_id.'.pdf')) { $file = $this->getFilePath($order_id).'R'.$r_id.'.pdf'; } else { $file = $this->getFilePath($order_id).'R'.$rnr_nr.'.pdf'; } $text = $this->shop->render(WPSG_PATH_VIEW."/mods/mod_rechnungen/rechnungsmail.phtml", false); $to = $_REQUEST['wpsg_rechnungen_email']; $header = ""; $arFiles = array($file); $this->shop->sendMail($text, $to, 'rechnungsmail', $arFiles, $order_id); $this->shop->restoreTempLocale(); $this->db->importQuery(WPSG_TBL_OL, array( "cdate" => "NOW()", "o_id" => wpsg_q($this->shop->view['data']['id']), "title" => wpsg_q(wpsg_translate(__('Rechnungsmail an #1#', 'wpsg'), $to)), "mailtext" => wpsg_q($text) )); } if ($_REQUEST['wpsg_rechnungen_url'] == '1') { $this->shop->notifyURL( $this->shop->get_option('wpsg_rechnungen_url'), false, false, $this->shop->view['data']['id'], 2 ); } } $this->shop->restoreTempLocale(); } public function setOrderStatus($order_id, $status_id, $inform) { if ($this->shop->get_option('wpsg_mod_rechnungen_auto') != '2' || $status_id != 100) return; $this->writeAutoRechnung($order_id); } public function stornoAction() { $order_data = $this->shop->cache->loadOrder($_REQUEST['edit_id']); if (trim($order_data['language']) != '') $this->shop->setTempLocale($order_data['language']); $custom_data = @unserialize($this->shop->view['data']['custom_data']); $this->shop->view['basket'] = $custom_data['basket']; $rechnung = $this->db->fetchRow("SELECT * FROM `".WPSG_TBL_RECHNUNGEN."` WHERE `o_id` = '".wpsg_q($_REQUEST['edit_id'])."' AND `storno` = '0000-00-00 00:00:00'"); $last_rnr = $this->db->fetchOne("
				SELECT
					`rnr`
				FROM
					`".WPSG_TBL_RECHNUNGEN."`
				WHERE
					`storno` = '0000-00-00 00:00:00' AND 
					`rnr` != '' AND
					`o_id` = '".wpsg_q($_REQUEST['edit_id'])."'
			"); $this->db->UpdateQuery( WPSG_TBL_RECHNUNGEN, array( "storno" => "NOW()" ), "`o_id` = '".wpsg_q($_REQUEST['edit_id'])."' AND `gnr` = ''" ); $this->shop->setOrderStatus($_REQUEST['edit_id'], 500, false); if ($_REQUEST['wpsg_rechnungen_gutschrift'] == "1" || $_REQUEST['wpsg_rechnungen_gutschrift'] == "2") { $gnr_format = $this->shop->get_option("wpsg_gutschrift_format"); if ($gnr_format == "") $gnr_format = "%nr%"; $gnr_nr = intval($this->shop->get_option("wpsg_gutschrift_start")); if ($gnr_nr <= 0) $gnr_nr = 1; $gnr = preg_replace("/\%nr\%/i", $gnr_nr, $gnr_format); $gnr = preg_replace("/\%Jahr\%/i", date("Y"), $gnr); $gnr = preg_replace("/\%Monat\%/i", date("m"), $gnr); $gnr = preg_replace("/\%Tag\%/i", date("d"), $gnr); $this->db->ImportQuery(WPSG_TBL_RECHNUNGEN, array( "o_id" => $_REQUEST['edit_id'], "datum" => "NOW()", "rnr" => "", "gnr" => $gnr )); $this->shop->update_option("wpsg_gutschrift_start", ($gnr_nr + 1)); $this->writeGutschrift($_REQUEST['edit_id'], $gnr); if ($_REQUEST['wpsg_rechnungen_gutschrift'] == "2") { $mail_text = $this->shop->render(WPSG_PATH_VIEW."/mods/mod_rechnungen/gutschriftmail.phtml", false); $file = $this->getFilePath($_REQUEST['edit_id']).'/G'.$gnr.'.pdf'; $arFiles = array($file); $this->shop->sendMail($mail_text, $this->shop->view['kunde']['email'], 'gutschriftmail', $arFiles); $this->shop->restoreTempLocale(); $this->db->ImportQuery(WPSG_TBL_OL, array( "o_id" => $_REQUEST['edit_id'], "cdate" => "NOW()", "title" => wpsg_translate(__('Gutschriftsmail an #1#', 'wpsg'), $this->shop->view['kunde']['email']), "mailtext" => $mail_text )); } die(); } $this->shop->restoreTempLocale(); $this->shop->addBackendMessage(__('Rechnung wurde erfolgreich storniert', 'wpsg')); header('Location: '.WPSG_URL_WP.'wp-admin/admin.php?page=wpsg-Order&action=view&edit_id='.$_REQUEST['edit_id']); die(); } private function doDownload($r_id) { $rechnung = $this->db->fetchRow("SELECT * FROM `".WPSG_TBL_RECHNUNGEN."` WHERE `id` = '".wpsg_q($r_id)."'"); if ($rechnung['gnr'] != "") { if (file_exists($this->getFilePath($rechnung['o_id']).$rechnung['gnr'].'.pdf')) { $file = $this->getFilePath($rechnung['o_id']).$rechnung['gnr'].'.pdf'; header('Content-Disposition: attachment; filename="'.$rechnung['gnr'].'.pdf"'); } else if (file_exists($this->getFilePath($rechnung['o_id']).'G'.$rechnung['id'].'.pdf')) { $file = $this->getFilePath($rechnung['o_id']).'G'.$rechnung['id'].'.pdf'; header('Content-Disposition: attachment; filename="'.$rechnung['gnr'].'.pdf"'); } else { $file = $this->getFilePath($rechnung['o_id']).'G'.$rechnung['gnr'].'.pdf'; header('Content-Disposition: attachment; filename="'.$rechnung['gnr'].'.pdf"'); } } else { if (file_exists($this->getFilePath($rechnung['o_id']).$rechnung['rnr'].'.pdf')) { $file = $this->getFilePath($rechnung['o_id']).$rechnung['rnr'].'.pdf'; header('Content-Disposition: attachment; filename="'.$rechnung['rnr'].'.pdf"'); } else if (file_exists($this->getFilePath($rechnung['o_id']).'R'.$rechnung['id'].'.pdf')) { $file = $this->getFilePath($rechnung['o_id']).'R'.$rechnung['id'].'.pdf'; header('Content-Disposition: attachment; filename="'.$rechnung['rnr'].'.pdf"'); } else { $file = $this->getFilePath($rechnung['o_id']).'R'.$rechnung['rnr'].'.pdf'; header('Content-Disposition: attachment; filename="'.$rechnung['rnr'].'.pdf"'); } } header("Cache-Control: no-cache, must-revalidate"); header("Expires: Sat, 26 Jul 1997 05:00:00 GMT"); header('Content-type: application/pdf'); die(file_get_contents($file)); } public function getFrontendLink($r_id) { $hash = md5($this->shop->get_option('wpsg_salt').'wpsg'.$r_id.'wpsg'.$this->shop->get_option('wpsg_salt')); $url = $this->shop->getURL(wpsg_ShopController::URL_BASKET); $url .= ((strpos($url, '?') === false)?'?wpsg_action=wpsg_mod_rechnungen_download':'&wpsg_action=wpsg_mod_rechnungen_download'); $url .= '&hash='.$hash.'&r_id='.$r_id; return $url; } public function getOrderInvoice($order_id) { $invoice_db = $this->db->fetchRow("
				SELECT
					R.*
				FROM
					`".WPSG_TBL_RECHNUNGEN."` AS R
				WHERE
					R.`o_id` = '".wpsg_q($order_id)."' AND
					R.`storno` = '0000-00-00 00:00:00' AND
					R.`gnr` = ''
				ORDER BY
					R.`datum` DESC
				LIMIT
					1
			"); if ($invoice_db['id'] > 0) { return $invoice_db; } return false; } public function getOrderCredit($order_id) { if ($this->getOrderInvoice($order_id) === false) { $credit_db = $this->db->fetchRow("
					SELECT
						R.* 
					FROM 
						`".WPSG_TBL_RECHNUNGEN."` AS R
					WHERE
						R.`o_id` = '".wpsg_q($order_id)."' AND
						R.`rnr` = '' AND
						R.`gnr` != ''
					ORDER BY
						R.`datum` DESC
					LIMIT
						1
				"); if ($credit_db['id'] > 0) { return $credit_db; } } return false; } public function resetAction() { $arData = array( "firma" => array("aktiv" => "1", "x" => "24", "y" => "10", "fontsize" => 8, "text" => "Firmenname", "color" => "#000000"), "name" => array("aktiv" => "1", "x" => "24", "y" => "13", "fontsize" => 8, "text" => "Inh. Max Mustermann", "color" => "#000000"), "strasse" => array("aktiv" => "1", "x" => "24", "y" => "16", "fontsize" => 8, "text" => "Musterstrasse 14", "color" => "#000000"), "plzort" => array("aktiv" => "1", "x" => "24", "y" => "19", "fontsize" => 8, "text" => "12345 Musterhausen", "color" => "#000000"), "tel" => array("aktiv" => "1", "x" => "75", "y" => "10", "fontsize" => 8, "text" => "Tel. 123456789-1", "color" => "#000000"), "fax" => array("aktiv" => "1", "x" => "75", "y" => "13", "fontsize" => 8, "text" => "Fax. 123456789-2", "color" => "#000000"), "mail" => array("aktiv" => "1", "x" => "75", "y" => "16", "fontsize" => 8, "text" => "Mail: max@mustermann.de", "color" => "#000000"), "web" => array("aktiv" => "1", "x" => "75", "y" => "19", "fontsize" => 8, "text" => "Web: http://muster-shop123.de", "color" => "#000000"), "strnr" => array("aktiv" => "1", "x" => "24", "y" => "270", "fontsize" => 8, "text" => "Steuer-Nr.: Ihre Steuernummer", "color" => "#000000"), "ustidnr" => array("aktiv" => "1", "x" => "24", "y" => "273", "fontsize" => 8, "text" => "USt-IdNr.: Ihre Umsatzsteuernummer", "color" => "#000000"), "knr" => array("aktiv" => "1", "x" => "24", "y" => "276", "fontsize" => 8, "text" => "Konto-Nr.: Ihre Kontonummer", "color" => "#000000"), "blz" => array("aktiv" => "1", "x" => "24", "y" => "279", "fontsize" => 8, "text" => "BLZ: BLZ ihrer Bank", "color" => "#000000"), "bank" => array("aktiv" => "1", "x" => "24", "y" => "282", "fontsize" => 8, "text" => "Bank: Name ihrer Banke", "color" => "#000000"), ); $this->shop->update_option("wpsg_rechnungen_adresszeile", "Absender: Firmenname Musterstrasse 14 12345 Musterhausen"); $this->shop->update_option("wpsg_mod_rechnungen_texte", $arData); } public function foottext_list() { $foot_text = $this->shop->get_option("wpsg_rechnungen_footer"); if (!is_array($foot_text)) $foot_text = @unserialize($foot_text); if (!is_array($foot_text)) $foot_text = array(); $this->shop->view['data'] = $foot_text; return $this->shop->render(WPSG_PATH_VIEW.'/mods/mod_rechnungen/foottext_list.phtml', false); } public function getFilePath($order_id, $url = false) { if ($this->shop->isMultiBlog()) { $path = WP_CONTENT_DIR.'/'.WPSG_MB_UPLOADS.'/wpsg/wpsg_rechnungen/'; $htaccess = WP_CONTENT_DIR.'/'.WPSG_MB_UPLOADS.'/wpsg/wpsg_rechnungen/.htaccess'; $url_content = WPSG_URL_CONTENT.'/'.WPSG_MB_UPLOADS.'/wpsg/wpsg_rechnungen/'; if ($url) $strReturn = $url_content.'/'.$order_id.'/'; else $strReturn = $path.'/'.$order_id.'/'; } else { $path = WPSG_PATH_WP.'/wp-content/uploads/wpsg_rechnungen/'; $htaccess = WPSG_PATH_WP.'/wp-content/uploads/wpsg_rechnungen/.htaccess'; if ($url) $strReturn = WPSG_URL_WP.'wp-content/uploads/wpsg_rechnungen/'.$order_id.'/'; else $strReturn = WPSG_PATH_WP.'/wp-content/uploads/wpsg_rechnungen/'.$order_id.'/'; } if (!file_exists($path)) { mkdir($path, 0777, true); } if (!file_exists($htaccess)) { $handle = fopen($htaccess, "w+"); $content = '
				
Deny from all

<Files wpsg_rechnungen_logo.jpg>
allow from all
</Files>

<Files wpsg_rechnungen_bp.jpg>
allow from all
</Files>

<Files wpsg_rechnungen_bp.pdf>
allow from all
</Files>

				'; fwrite($handle, $content, strlen($content)); fclose($handle); } return $strReturn; } private function writeAutoRechnung($order_id) { $order_data = $this->shop->cache->loadOrder($order_id); $customer_data = $this->shop->cache->loadKunden($order_data['k_id']); $_REQUEST['wpsg_rechnungen_sendmail'] = '1'; $_REQUEST['wpsg_rechnungen_email'] = wpsg_q($customer_data['email']); $_REQUEST['wpsg_rechnungen_fusstext'] = ''; $_REQUEST['wpsg_rechnungen_faelligkeit'] = '0'; $_REQUEST['wpsg_rechnungen_datum'] = date('d.m.Y'); if (intval($this->shop->get_option('wpsg_rechnungen_faelligkeit')) > 0) { $_REQUEST['wpsg_rechnungen_faelligkeit'] = '1'; $_REQUEST['wpsg_rechnungen_faelligkeitsdatum'] = date('d.m.Y', time() + intval($this->shop->get_option('wpsg_rechnungen_faelligkeit')) * 86400); } if ($this->shop->get_option('wpsg_rechnungen_foottext_standard') !== false) { $foot_text = $this->shop->get_option("wpsg_rechnungen_footer"); if (!is_array($foot_text)) $foot_text = @unserialize($foot_text); if (!is_array($foot_text)) $foot_text = array(); if (isset($foot_text[$this->shop->get_option('wpsg_rechnungen_foottext_standard')])) { $_REQUEST['wpsg_rechnungen_fusstext'] = $foot_text[$this->shop->get_option('wpsg_rechnungen_foottext_standard')][1]; } } $this->writeRechnung($order_id, $preview = false, $bOutput = false); } } ?>